Loading...
Searching...
No Matches
Ogre::TerrainGlobalOptions Class Reference
Optional Components » Terrain

Options class which just stores default options for the terrain. More...

`#include <OgreTerrain.h>`

Inheritance diagram for Ogre::TerrainGlobalOptions:
[legend]

## Public Member Functions

| TerrainGlobalOptions ()
| ~TerrainGlobalOptions ()
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
bool | getCastsDynamicShadows () const
| Whether the terrain will be able to cast shadows (texture shadows only are supported, and you must be using depth shadow maps).
const ColourValue & | getCompositeMapAmbient () const
| Get the composite map ambient light to use.
const ColourValue & | getCompositeMapDiffuse () const
| Get the composite map iffuse light to use.
Real | getCompositeMapDistance () const
| Get the distance at which to start using a composite map if present.
uint16 | getCompositeMapSize () const
| Get the default size of the composite maps for a new terrain.
uint16 | getDefaultGlobalColourMapSize () const
| Get the default size of the terrain global colour map for a new terrain.
Real | getDefaultLayerTextureWorldSize () const
| Get the default world size for a layer 'splat' texture to cover.
TerrainMaterialGeneratorPtr | getDefaultMaterialGenerator ()
| Get the default material generator.
const String & | getDefaultResourceGroup () const
| Get the default resource group to use to load / save terrains.
uint16 | getLayerBlendMapSize () const
| Get the default size of the blend maps for a new terrain.
const Vector3 & | getLightMapDirection () const
| Get the shadow map light direction to use (world space).
uint16 | getLightMapSize () const
| Get the default size of the lightmaps for a new terrain.
Real | getMaxPixelError () const
| Get the maximum screen pixel error that should be allowed when rendering.
uint32 | getQueryFlags (void) const
| Get the default query flags for terrains.
uint8 | getRenderQueueGroup (void) const
| Get the render queue group that this terrain will be rendered into.
Real | getSkirtSize () const
| The default size of 'skirts' used to hide terrain cracks (default 10).
bool | getUseRayBoxDistanceCalculation () const
| Returns whether or not to use an accurate calculation of camera distance from a terrain tile (ray / AABB intersection) or whether to use the simpler distance from the tile centre.
bool | getUseVertexCompressionWhenAvailable () const
| Get whether to allow vertex compression to be used when the material generator states that it supports it.
uint32 | getVisibilityFlags (void) const
| Get the visbility flags that terrains will be rendered with.
void | removeQueryFlags (uint32 flags)
void | setCastsDynamicShadows (bool s)
| Whether the terrain will be able to cast shadows (texture shadows only are supported, and you must be using depth shadow maps).
void | setCompositeMapAmbient (const ColourValue &c)
| Set the composite map ambient light to use.
void | setCompositeMapDiffuse (const ColourValue &c)
| Set the composite map diffuse light to use.
void | setCompositeMapDistance (Real c)
| Set the distance at which to start using a composite map if present.
void | setCompositeMapSize (uint16 sz)
| Sets the default size of composite maps for a new terrain.
void | setDefaultGlobalColourMapSize (uint16 sz)
| Set the default size of the terrain global colour map for a new terrain.
void | setDefaultLayerTextureWorldSize (Real sz)
| Set the default world size for a layer 'splat' texture to cover.
void | setDefaultMaterialGenerator (const TerrainMaterialGeneratorPtr &gen)
| Set the default material generator.
void | setDefaultResourceGroup (const String &grp)
| Set the default resource group to use to load / save terrains.
void | setLayerBlendMapSize (uint16 sz)
| Sets the default size of blend maps for a new terrain.
void | setLightMapDirection (const Vector3 &v)
| Set the shadow map light direction to use (world space).
void | setLightMapSize (uint16 sz)
| Sets the default size of lightmaps for a new terrain.
void | setMaxPixelError (Real pixerr)
| Set the maximum screen pixel error that should be allowed when rendering.
void | setQueryFlags (uint32 flags)
| Set the default query flags for terrains.
void | setRenderQueueGroup (uint8 grp)
| Set the render queue group that terrains will be rendered into.
void | setSkirtSize (Real skirtSz)
| method - the default size of 'skirts' used to hide terrain cracks (default 10)
void | setUseRayBoxDistanceCalculation (bool rb)
| Sets whether to use an accurate ray / box intersection to determine distance from a terrain tile, or whether to use the simple distance from the tile centre.
void | setUseVertexCompressionWhenAvailable (bool enable)
| Set whether to allow vertex compression to be used when the material generator states that it supports it.
void | setVisibilityFlags (uint32 flags)
| Set the visbility flags that terrains will be rendered with.
Public Member Functions inherited from Ogre::Singleton< TerrainGlobalOptions >
| ~Singleton (void)

## Static Public Member Functions

static TerrainGlobalOptions & | getSingleton (void)
| Get the singleton instance.
static TerrainGlobalOptions * | getSingletonPtr (void)
| Get the singleton instance.
Static Public Member Functions inherited from Ogre::Singleton< TerrainGlobalOptions >
static TerrainGlobalOptions & | getSingleton (void)
| Get the singleton instance.
static TerrainGlobalOptions * | getSingletonPtr (void)
| Get the singleton instance.

## Detailed Description

Options class which just stores default options for the terrain.

None of these options are stored with the terrain when saved. They are options that you can use to modify the behaviour of the terrain when it is loaded or created.

Note
  You should construct a single instance of this class per application and do so before you start working with any other terrain classes.

## Constructor & Destructor Documentation

## TerrainGlobalOptions()

Ogre::TerrainGlobalOptions::TerrainGlobalOptions | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ~TerrainGlobalOptions()

Ogre::TerrainGlobalOptions::~TerrainGlobalOptions | ( |  | ) |

## Member Function Documentation

## getSkirtSize()

Real Ogre::TerrainGlobalOptions::getSkirtSize | ( |  | ) | const

inline

The default size of 'skirts' used to hide terrain cracks (default 10).

## setSkirtSize()

void Ogre::TerrainGlobalOptions::setSkirtSize | ( | Real | skirtSz | ) |

inline

method - the default size of 'skirts' used to hide terrain cracks (default 10)

Note
  Changing this value only applies to Terrain instances loaded / reloaded afterwards.

## getLightMapDirection()

const Vector3 & Ogre::TerrainGlobalOptions::getLightMapDirection | ( |  | ) | const

inline

Get the shadow map light direction to use (world space).

## setLightMapDirection()

void Ogre::TerrainGlobalOptions::setLightMapDirection | ( | const Vector3 & | v | ) |

inline

Set the shadow map light direction to use (world space).

## getCompositeMapAmbient()

const ColourValue & Ogre::TerrainGlobalOptions::getCompositeMapAmbient | ( |  | ) | const

inline

Get the composite map ambient light to use.

## setCompositeMapAmbient()

void Ogre::TerrainGlobalOptions::setCompositeMapAmbient | ( | const ColourValue & | c | ) |

inline

Set the composite map ambient light to use.

## getCompositeMapDiffuse()

const ColourValue & Ogre::TerrainGlobalOptions::getCompositeMapDiffuse | ( |  | ) | const

inline

Get the composite map iffuse light to use.

## setCompositeMapDiffuse()

void Ogre::TerrainGlobalOptions::setCompositeMapDiffuse | ( | const ColourValue & | c | ) |

inline

Set the composite map diffuse light to use.

## getCompositeMapDistance()

Real Ogre::TerrainGlobalOptions::getCompositeMapDistance | ( |  | ) | const

inline

Get the distance at which to start using a composite map if present.

## setCompositeMapDistance()

void Ogre::TerrainGlobalOptions::setCompositeMapDistance | ( | Real | c | ) |

inline

Set the distance at which to start using a composite map if present.

## getCastsDynamicShadows()

bool Ogre::TerrainGlobalOptions::getCastsDynamicShadows | ( |  | ) | const

inline

Whether the terrain will be able to cast shadows (texture shadows only are supported, and you must be using depth shadow maps).

## setCastsDynamicShadows()

void Ogre::TerrainGlobalOptions::setCastsDynamicShadows | ( | bool | s | ) |

inline

Whether the terrain will be able to cast shadows (texture shadows only are supported, and you must be using depth shadow maps).

This value can be set dynamically, and affects all existing terrains. It defaults to false.

## getMaxPixelError()

Real Ogre::TerrainGlobalOptions::getMaxPixelError | ( |  | ) | const

inline

Get the maximum screen pixel error that should be allowed when rendering.

## setMaxPixelError()

void Ogre::TerrainGlobalOptions::setMaxPixelError | ( | Real | pixerr | ) |

inline

Set the maximum screen pixel error that should be allowed when rendering.

Note
  This value can be varied dynamically and affects all existing terrains. It will be weighted by the LOD bias on viewports.

## getRenderQueueGroup()

uint8 Ogre::TerrainGlobalOptions::getRenderQueueGroup | ( | void |  | ) | const

inline

Get the render queue group that this terrain will be rendered into.

## setRenderQueueGroup()

void Ogre::TerrainGlobalOptions::setRenderQueueGroup | ( | uint8 | grp | ) |

inline

Set the render queue group that terrains will be rendered into.

Remarks
  This applies to newly created terrains, after which they will maintain their own queue group settings

## getVisibilityFlags()

uint32 Ogre::TerrainGlobalOptions::getVisibilityFlags | ( | void |  | ) | const

inline

Get the visbility flags that terrains will be rendered with.

## setVisibilityFlags()

void Ogre::TerrainGlobalOptions::setVisibilityFlags | ( | uint32 | flags | ) |

inline

Set the visbility flags that terrains will be rendered with.

Remarks
  This applies to newly created terrains, after which they will maintain their own settings

## setQueryFlags()

void Ogre::TerrainGlobalOptions::setQueryFlags | ( | uint32 | flags | ) |

inline

Set the default query flags for terrains.

Remarks
  This applies to newly created terrains, after which they will maintain their own settings

## getQueryFlags()

uint32 Ogre::TerrainGlobalOptions::getQueryFlags | ( | void |  | ) | const

inline

Get the default query flags for terrains.

## addQueryFlags()

void Ogre::TerrainGlobalOptions::addQueryFlags | ( | uint32 | flags | ) |

inline

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## removeQueryFlags()

void Ogre::TerrainGlobalOptions::removeQueryFlags | ( | uint32 | flags | ) |

inline

## getUseRayBoxDistanceCalculation()

bool Ogre::TerrainGlobalOptions::getUseRayBoxDistanceCalculation | ( |  | ) | const

inline

Returns whether or not to use an accurate calculation of camera distance from a terrain tile (ray / AABB intersection) or whether to use the simpler distance from the tile centre.

## setUseRayBoxDistanceCalculation()

void Ogre::TerrainGlobalOptions::setUseRayBoxDistanceCalculation | ( | bool | rb | ) |

inline

Sets whether to use an accurate ray / box intersection to determine distance from a terrain tile, or whether to use the simple distance from the tile centre.

Using ray/box intersection will result in higher detail terrain because the LOD calculation is more conservative, assuming the 'worst case scenario' of a large height difference at the edge of a tile. This is guaranteed to give you at least the max pixel error or better, but will often give you more detail than you need. Not using the ray/box method is cheaper but will only use the max pixel error as a guide, the actual error will vary above and below that. The default is not to use the ray/box approach.

## getDefaultMaterialGenerator()

TerrainMaterialGeneratorPtr Ogre::TerrainGlobalOptions::getDefaultMaterialGenerator | ( |  | ) |

Get the default material generator.

## setDefaultMaterialGenerator()

void Ogre::TerrainGlobalOptions::setDefaultMaterialGenerator | ( | const TerrainMaterialGeneratorPtr & | gen | ) |

Set the default material generator.

## getLayerBlendMapSize()

uint16 Ogre::TerrainGlobalOptions::getLayerBlendMapSize | ( |  | ) | const

inline

Get the default size of the blend maps for a new terrain.

## setLayerBlendMapSize()

void Ogre::TerrainGlobalOptions::setLayerBlendMapSize | ( | uint16 | sz | ) |

inline

Sets the default size of blend maps for a new terrain.

This is the resolution of each blending layer for a new terrain. Once created, this information will be stored with the terrain.

## getDefaultLayerTextureWorldSize()

Real Ogre::TerrainGlobalOptions::getDefaultLayerTextureWorldSize | ( |  | ) | const

inline

Get the default world size for a layer 'splat' texture to cover.

## setDefaultLayerTextureWorldSize()

void Ogre::TerrainGlobalOptions::setDefaultLayerTextureWorldSize | ( | Real | sz | ) |

inline

Set the default world size for a layer 'splat' texture to cover.

## getDefaultGlobalColourMapSize()

uint16 Ogre::TerrainGlobalOptions::getDefaultGlobalColourMapSize | ( |  | ) | const

inline

Get the default size of the terrain global colour map for a new terrain.

## setDefaultGlobalColourMapSize()

void Ogre::TerrainGlobalOptions::setDefaultGlobalColourMapSize | ( | uint16 | sz | ) |

inline

Set the default size of the terrain global colour map for a new terrain.

Once created, this information will be stored with the terrain.

## getLightMapSize()

uint16 Ogre::TerrainGlobalOptions::getLightMapSize | ( |  | ) | const

inline

Get the default size of the lightmaps for a new terrain.

## setLightMapSize()

void Ogre::TerrainGlobalOptions::setLightMapSize | ( | uint16 | sz | ) |

inline

Sets the default size of lightmaps for a new terrain.

## getCompositeMapSize()

uint16 Ogre::TerrainGlobalOptions::getCompositeMapSize | ( |  | ) | const

inline

Get the default size of the composite maps for a new terrain.

## setCompositeMapSize()

void Ogre::TerrainGlobalOptions::setCompositeMapSize | ( | uint16 | sz | ) |

inline

Sets the default size of composite maps for a new terrain.

## setDefaultResourceGroup()

void Ogre::TerrainGlobalOptions::setDefaultResourceGroup | ( | const String & | grp | ) |

inline

Set the default resource group to use to load / save terrains.

## getDefaultResourceGroup()

const String & Ogre::TerrainGlobalOptions::getDefaultResourceGroup | ( |  | ) | const

inline

Get the default resource group to use to load / save terrains.

## getUseVertexCompressionWhenAvailable()

bool Ogre::TerrainGlobalOptions::getUseVertexCompressionWhenAvailable | ( |  | ) | const

inline

Get whether to allow vertex compression to be used when the material generator states that it supports it.

## setUseVertexCompressionWhenAvailable()

void Ogre::TerrainGlobalOptions::setUseVertexCompressionWhenAvailable | ( | bool | enable | ) |

inline

Set whether to allow vertex compression to be used when the material generator states that it supports it.

Note
  You should only call this before creating any terrain instances. The default is true, so if a material generator supports compressed vertices, and so does the hardware (this basically means shader support), they will be used). However you can disable this in an emergency if required.

## getSingleton()

TerrainGlobalOptions & Ogre::TerrainGlobalOptions::getSingleton | ( | void |  | ) |

static

Get the singleton instance.

References TerrainGlobalOptions().

## getSingletonPtr()

TerrainGlobalOptions * Ogre::TerrainGlobalOptions::getSingletonPtr | ( | void |  | ) |

static

Get the singleton instance.

References TerrainGlobalOptions().

The documentation for this class was generated from the following file:

- OgreTerrain.h